import * as types from "../actionTypes";

const initilalState = {
	list: [],
	item: {
		id: "",
		name: ""
	},
	editMode: false
};

export default (state = initilalState, action) => {
	switch (action.type) {
		case types.ADD_TO_LIST: {
			if (!state.item.name) {
				return state;
			}

			if (state.editMode) {
				return {
					...state,
					list: state.list.map(el => (el.id === state.item.id ? state.item : el)),
					editMode: false,
					item: initilalState.item
				};
			}

			const newItem = {
				...state.item,
				id: Date.now().toString()
			};

			return {
				...state,
				editMode: false,
				item: initilalState.item,
				list: state.list.concat(newItem)
			};
		}
		case types.GET_ALL_LIST: {
			return {
				...state,
				list: action.payload
			};
		}
		case types.UPDATE_ITEM_NAME: {
			return {
				...state,
				item: {
					...state.item,
					name: action.payload
				}
			};
		}
		case types.REMOVE_ITEM: {
			return {
				...state,
				editMode: false,
				list: state.list.filter(el => el.id !== action.payload)
			};
		}
		case types.SET_ITEM_TO_UPDATE: {
			console.log("SET_ITEM_TO_UPDATE", action);
			const item = state.list.find(el => el.id === action.payload);

			return {
				...state,
				editMode: true,
				item
			};
		}

		default: {
			return state;
		}
	}
};
